#include <string>
#include <stdexcept>
#include <cstdarg>
#include <cstdio>

namespace stl_ut {

/*
 *  bool stl_ut::Format(std::string &r_s_result, const char *p_s_fmt, ...)
 *      - equivalent of standard "c" library sprintf function,
 *        working with std::string output
 *      - returns true on success, false on failure (not enough memory)
 *      - note this is safe against output buffer overrun, but is
 *        still susceptible to ill-formated format string (p_s_fmt)
 *        and bad arguments (not enough of them / not corresponding
 *        to tags in the format string). but as the first one being run-time
 *        error and the latter one compile-time error, this brings
 *        enought improvement.
 */
bool Format(std::string &r_s_result, const char *p_s_fmt, ...);

}

#include <stdint.h>

#if defined(_WIN32) || defined (_WIN64)
#define WIN32_LEAND_AND_MEAN 1
#include <windows.h>
#endif // _WIN32, _WIN64
