//                              --- OpenGL 2.0 ---

/**
 *  @def GL_VERSION_2_0
 *  @brief if defined, OpenGL 2.0 entry points are available
 *  @note This does not necessarily mean it is also supported.
 */
#ifndef GL_VERSION_2_0
#define GL_VERSION_2_0 1

/**
 *  @def __GENERATE_GL_20__
 *  @brief if defined, code to initialize OpenGL 2.0 entry points is compiled
 */
#define __GENERATE_GL_20__

extern bool GLEH_OPENGL_2_0; /**< @brief set if OpenGL 2.0 is supported */

#define GL_BLEND_EQUATION_RGB                                       0x8009 /**< @brief OpenGL 2.0 enum */
#define GL_VERTEX_ATTRIB_ARRAY_ENABLED                              0x8622 /**< @brief OpenGL 2.0 enum */
#define GL_VERTEX_ATTRIB_ARRAY_SIZE                                 0x8623 /**< @brief OpenGL 2.0 enum */
#define GL_VERTEX_ATTRIB_ARRAY_STRIDE                               0x8624 /**< @brief OpenGL 2.0 enum */
#define GL_VERTEX_ATTRIB_ARRAY_TYPE                                 0x8625 /**< @brief OpenGL 2.0 enum */
#define GL_CURRENT_VERTEX_ATTRIB                                    0x8626 /**< @brief OpenGL 2.0 enum */
//#define GL_VERTEX_PROGRAM_POINT_SIZE                                0x8642 // deprecated (in OpenGL 3.2; use GL_PROGRAM_POINT_SIZE)
//#define GL_VERTEX_PROGRAM_TWO_SIDE                                  0x8643 // deprecated
#define GL_VERTEX_ATTRIB_ARRAY_POINTER                              0x8645 /**< @brief OpenGL 2.0 enum */
//#define GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING                       0x889F // deprecated
#define GL_STENCIL_BACK_FUNC                                        0x8800 /**< @brief OpenGL 2.0 enum */
#define GL_STENCIL_BACK_FAIL                                        0x8801 /**< @brief OpenGL 2.0 enum */
#define GL_STENCIL_BACK_PASS_DEPTH_FAIL                             0x8802 /**< @brief OpenGL 2.0 enum */
#define GL_STENCIL_BACK_PASS_DEPTH_PASS                             0x8803 /**< @brief OpenGL 2.0 enum */
#define GL_MAX_DRAW_BUFFERS                                         0x8824 /**< @brief OpenGL 2.0 enum */
#define GL_DRAW_BUFFER0                                             0x8825 /**< @brief OpenGL 2.0 enum */
#define GL_DRAW_BUFFER1                                             0x8826 /**< @brief OpenGL 2.0 enum */
#define GL_DRAW_BUFFER2                                             0x8827 /**< @brief OpenGL 2.0 enum */
#define GL_DRAW_BUFFER3                                             0x8828 /**< @brief OpenGL 2.0 enum */
#define GL_DRAW_BUFFER4                                             0x8829 /**< @brief OpenGL 2.0 enum */
#define GL_DRAW_BUFFER5                                             0x882A /**< @brief OpenGL 2.0 enum */
#define GL_DRAW_BUFFER6                                             0x882B /**< @brief OpenGL 2.0 enum */
#define GL_DRAW_BUFFER7                                             0x882C /**< @brief OpenGL 2.0 enum */
#define GL_DRAW_BUFFER8                                             0x882D /**< @brief OpenGL 2.0 enum */
#define GL_DRAW_BUFFER9                                             0x882E /**< @brief OpenGL 2.0 enum */
#define GL_DRAW_BUFFER10                                            0x882F /**< @brief OpenGL 2.0 enum */
#define GL_DRAW_BUFFER11                                            0x8830 /**< @brief OpenGL 2.0 enum */
#define GL_DRAW_BUFFER12                                            0x8831 /**< @brief OpenGL 2.0 enum */
#define GL_DRAW_BUFFER13                                            0x8832 /**< @brief OpenGL 2.0 enum */
#define GL_DRAW_BUFFER14                                            0x8833 /**< @brief OpenGL 2.0 enum */
#define GL_DRAW_BUFFER15                                            0x8834 /**< @brief OpenGL 2.0 enum */
#define GL_BLEND_EQUATION_ALPHA                                     0x883D /**< @brief OpenGL 2.0 enum */
#define GL_MAX_VERTEX_ATTRIBS                                       0x8869 /**< @brief OpenGL 2.0 enum */
#define GL_VERTEX_ATTRIB_ARRAY_NORMALIZED                           0x886A /**< @brief OpenGL 2.0 enum */
#define GL_MAX_TEXTURE_IMAGE_UNITS                                  0x8872 /**< @brief OpenGL 2.0 enum */
#define GL_FRAGMENT_SHADER                                          0x8B30 /**< @brief OpenGL 2.0 enum */
#define GL_VERTEX_SHADER                                            0x8B31 /**< @brief OpenGL 2.0 enum */
#define GL_MAX_FRAGMENT_UNIFORM_COMPONENTS                          0x8B49 /**< @brief OpenGL 2.0 enum */
#define GL_MAX_VERTEX_UNIFORM_COMPONENTS                            0x8B4A /**< @brief OpenGL 2.0 enum */
//#define GL_MAX_VARYING_FLOATS                                       0x8B4B // deprecated
#define GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS                           0x8B4C /**< @brief OpenGL 2.0 enum */
#define GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS                         0x8B4D /**< @brief OpenGL 2.0 enum */
//#define GL_MAX_TEXTURE_COORDS                                       0x8871 // deprecated
#define GL_SHADER_TYPE                                              0x8B4F /**< @brief OpenGL 2.0 enum */
#define GL_FLOAT_VEC2                                               0x8B50 /**< @brief OpenGL 2.0 enum */
#define GL_FLOAT_VEC3                                               0x8B51 /**< @brief OpenGL 2.0 enum */
#define GL_FLOAT_VEC4                                               0x8B52 /**< @brief OpenGL 2.0 enum */
#define GL_INT_VEC2                                                 0x8B53 /**< @brief OpenGL 2.0 enum */
#define GL_INT_VEC3                                                 0x8B54 /**< @brief OpenGL 2.0 enum */
#define GL_INT_VEC4                                                 0x8B55 /**< @brief OpenGL 2.0 enum */
#define GL_BOOL                                                     0x8B56 /**< @brief OpenGL 2.0 enum */
#define GL_BOOL_VEC2                                                0x8B57 /**< @brief OpenGL 2.0 enum */
#define GL_BOOL_VEC3                                                0x8B58 /**< @brief OpenGL 2.0 enum */
#define GL_BOOL_VEC4                                                0x8B59 /**< @brief OpenGL 2.0 enum */
#define GL_FLOAT_MAT2                                               0x8B5A /**< @brief OpenGL 2.0 enum */
#define GL_FLOAT_MAT3                                               0x8B5B /**< @brief OpenGL 2.0 enum */
#define GL_FLOAT_MAT4                                               0x8B5C /**< @brief OpenGL 2.0 enum */
#define GL_SAMPLER_1D                                               0x8B5D /**< @brief OpenGL 2.0 enum */
#define GL_SAMPLER_2D                                               0x8B5E /**< @brief OpenGL 2.0 enum */
#define GL_SAMPLER_3D                                               0x8B5F /**< @brief OpenGL 2.0 enum */
#define GL_SAMPLER_CUBE                                             0x8B60 /**< @brief OpenGL 2.0 enum */
#define GL_SAMPLER_1D_SHADOW                                        0x8B61 /**< @brief OpenGL 2.0 enum */
#define GL_SAMPLER_2D_SHADOW                                        0x8B62 /**< @brief OpenGL 2.0 enum */
#define GL_DELETE_STATUS                                            0x8B80 /**< @brief OpenGL 2.0 enum */
#define GL_COMPILE_STATUS                                           0x8B81 /**< @brief OpenGL 2.0 enum */
#define GL_LINK_STATUS                                              0x8B82 /**< @brief OpenGL 2.0 enum */
#define GL_VALIDATE_STATUS                                          0x8B83 /**< @brief OpenGL 2.0 enum */
#define GL_INFO_LOG_LENGTH                                          0x8B84 /**< @brief OpenGL 2.0 enum */
#define GL_ATTACHED_SHADERS                                         0x8B85 /**< @brief OpenGL 2.0 enum */
#define GL_ACTIVE_UNIFORMS                                          0x8B86 /**< @brief OpenGL 2.0 enum */
#define GL_ACTIVE_UNIFORM_MAX_LENGTH                                0x8B87 /**< @brief OpenGL 2.0 enum */
#define GL_SHADER_SOURCE_LENGTH                                     0x8B88 /**< @brief OpenGL 2.0 enum */
#define GL_ACTIVE_ATTRIBUTES                                        0x8B89 /**< @brief OpenGL 2.0 enum */
#define GL_ACTIVE_ATTRIBUTE_MAX_LENGTH                              0x8B8A /**< @brief OpenGL 2.0 enum */
#define GL_FRAGMENT_SHADER_DERIVATIVE_HINT                          0x8B8B /**< @brief OpenGL 2.0 enum */
#define GL_SHADING_LANGUAGE_VERSION                                 0x8B8C /**< @brief OpenGL 2.0 enum */
#define GL_CURRENT_PROGRAM                                          0x8B8D /**< @brief OpenGL 2.0 enum */
//#define GL_POINT_SPRITE                                             0x8861 // deprecated
//#define GL_COORD_REPLACE                                            0x8862 // deprecated
#define GL_POINT_SPRITE_COORD_ORIGIN                                0x8CA0 /**< @brief OpenGL 2.0 enum */
#define GL_LOWER_LEFT                                               0x8CA1 /**< @brief OpenGL 2.0 enum */
#define GL_UPPER_LEFT                                               0x8CA2 /**< @brief OpenGL 2.0 enum */
#define GL_STENCIL_BACK_REF                                         0x8CA3 /**< @brief OpenGL 2.0 enum */
#define GL_STENCIL_BACK_VALUE_MASK                                  0x8CA4 /**< @brief OpenGL 2.0 enum */
#define GL_STENCIL_BACK_WRITEMASK                                   0x8CA5 /**< @brief OpenGL 2.0 enum */

/**
 *  @brief set the RGB blend equation and the alpha blend equation separately
 *  @param[in] modeRGB specifies the RGB blend equation, how the red, green, and blue components of
 *      the source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT,
 *      GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
 *  @param[in] modeAlpha specifies the alpha blend equation, how the alpha component of the source
 *      and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT,
 *      GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
 */
extern void (GLApi *GLFuncPtrName(glBlendEquationSeparate))(GLenum modeRGB, GLenum modeAlpha);

/**
 *  @brief Specifies a list of color buffers to be drawn into
 *  @param[in] n Specifies the number of buffers in bufs.
 *  @param[in] bufs Points to an array of symbolic constants specifying the buffers into which
 *      fragment colors or data values will be written.
 */
extern void (GLApi *GLFuncPtrName(glDrawBuffers))(GLsizei n, const GLenum *bufs);

/**
 *  @brief set front and/or back stencil test actions
 *  @param[in] face Specifies whether front and/or back stencil state is updated. Three symbolic
 *      constants are valid: GL_FRONT, GL_BACK, and GL_FRONT_AND_BACK.
 *  @param[in] sfail Specifies the action to take when the stencil test fails. Eight symbolic
 *      constants are accepted: GL_KEEP, GL_ZERO, GL_REPLACE, GL_INCR, GL_INCR_WRAP, GL_DECR,
 *      GL_DECR_WRAP, and GL_INVERT. The initial value is GL_KEEP.
 *  @param[in] dpfail Specifies the stencil action when the stencil test passes, but the depth test
 *      fails. dpfail accepts the same symbolic constants as sfail. The initial value is GL_KEEP.
 *  @param[in] dppass Specifies the stencil action when both the stencil test and the depth test
 *      pass, or when the stencil test passes and either there is no depth buffer or depth testing
 *      is not enabled. dppass accepts the same symbolic constants as sfail. The initial value is GL_KEEP.
 */
extern void (GLApi *GLFuncPtrName(glStencilOpSeparate))(GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass);

/**
 *  @brief set front and/or back function and reference value for stencil testing
 *  @param[in] face Specifies whether front and/or back stencil state is updated. Three symbolic
 *      constants are valid: GL_FRONT, GL_BACK, and GL_FRONT_AND_BACK.
 *  @param[in] func Specifies the test function. Eight symbolic constants are valid: GL_NEVER,
 *      GL_LESS, GL_LEQUAL, GL_GREATER, GL_GEQUAL, GL_EQUAL, GL_NOTEQUAL, and GL_ALWAYS. The initial
 *      value is GL_ALWAYS.
 *  @param[in] ref Specifies the reference value for the stencil test. ref is clamped to the range 0
 *      2 n - 1, where n is the number of bitplanes in the stencil buffer. The initial value is 0.
 *  @param[in] mask Specifies a mask that is ANDed with both the reference value and the stored
 *      stencil value when the test is done. The initial value is all 1's.
 */
extern void (GLApi *GLFuncPtrName(glStencilFuncSeparate))(GLenum face, GLenum func, int ref, GLuint mask);

/**
 *  @brief control the front and/or back writing of individual bits in the stencil planes
 *  @param[in] face Specifies whether the front and/or back stencil writemask is updated. Three
 *      symbolic constants are valid: GL_FRONT, GL_BACK, and GL_FRONT_AND_BACK.
 *  @param[in] mask Specifies a bit mask to enable and disable writing of individual bits in the
 *      stencil planes. Initially, the mask is all 1's.
 */
extern void (GLApi *GLFuncPtrName(glStencilMaskSeparate))(GLenum face, GLuint mask);

/**
 *  @brief Attaches a shader object to a program object
 *  @param[in] program Specifies the program object to which a shader object will be attached.
 *  @param[in] shader Specifies the shader object that is to be attached.
 */
extern void (GLApi *GLFuncPtrName(glAttachShader))(GLuint program, GLuint shader);

/**
 *  @brief Associates a generic vertex attribute index with a named attribute variable
 *  @param[in] program Specifies the handle of the program object in which the association is to be made.
 *  @param[in] index Specifies the index of the generic vertex attribute to be bound.
 *  @param[in] name Specifies a null terminated string containing the name of the vertex shader
 *      attribute variable to which index is to be bound.
 */
extern void (GLApi *GLFuncPtrName(glBindAttribLocation))(GLuint program, GLuint index, const GLchar *name);

/**
 *  @brief Compiles a shader object
 *  @param[in] shader Specifies the shader object to be compiled.
 */
extern void (GLApi *GLFuncPtrName(glCompileShader))(GLuint shader);

/**
 *  @brief Creates a program object
 */
extern GLuint (GLApi *GLFuncPtrName(glCreateProgram))();

/**
 *  @brief Creates a shader object
 *  @param[in] shaderType Specifies the type of shader to be created. Must be one of
 *      GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER, or GL_FRAGMENT_SHADER.
 */
extern GLuint (GLApi *GLFuncPtrName(glCreateShader))(GLenum shaderType);

/**
 *  @brief Deletes a program object
 *  @param[in] program Specifies the program object to be deleted.
 */
extern void (GLApi *GLFuncPtrName(glDeleteProgram))(GLuint program);

/**
 *  @brief Deletes a shader object
 *  @param[in] shader Specifies the shader object to be deleted.
 */
extern void (GLApi *GLFuncPtrName(glDeleteShader))(GLuint shader);

/**
 *  @brief Detaches a shader object from a program object to which it is attached
 *  @param[in] program Specifies the program object from which to detach the shader object.
 *  @param[in] shader Specifies the shader object to be detached.
 */
extern void (GLApi *GLFuncPtrName(glDetachShader))(GLuint program, GLuint shader);

/**
 *  @brief Enable or disable a generic vertex attribute array
 *  @param[in] index Specifies the index of the generic vertex attribute to be enabled or disabled.
 */
extern void (GLApi *GLFuncPtrName(glDisableVertexAttribArray))(GLuint index);

/**
 *  @brief Enable or disable a generic vertex attribute array
 *  @param[in] index Specifies the index of the generic vertex attribute to be enabled or disabled.
 */
extern void (GLApi *GLFuncPtrName(glEnableVertexAttribArray))(GLuint index);

/**
 *  @brief Returns information about an active attribute variable for the specified program object
 *  @param[in] program Specifies the program object to be queried.
 *  @param[in] index Specifies the index of the attribute variable to be queried.
 *  @param[in] bufSize Specifies the maximum number of characters OpenGL is allowed to write in the
 *      character buffer indicated by name.
 *  @param[out] length Returns the number of characters actually written by OpenGL in the string
 *      indicated by name (excluding the null terminator) if a value other than NULL is passed.
 *  @param[out] size Returns the size of the attribute variable.
 *  @param[out] type Returns the data type of the attribute variable.
 *  @param[out] name Returns a null terminated string containing the name of the attribute variable.
 */
extern void (GLApi *GLFuncPtrName(glGetActiveAttrib))(GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLsizei *size, GLenum *type, GLchar *name);

/**
 *  @brief Returns information about an active uniform variable for the specified program object
 *  @param[in] program Specifies the program object to be queried.
 *  @param[in] index Specifies the index of the uniform variable to be queried.
 *  @param[in] bufSize Specifies the maximum number of characters OpenGL is allowed to write in the
 *      character buffer indicated by name.
 *  @param[out] length Returns the number of characters actually written by OpenGL in the string
 *      indicated by name (excluding the null terminator) if a value other than NULL is passed.
 *  @param[out] size Returns the size of the uniform variable.
 *  @param[out] type Returns the data type of the uniform variable.
 *  @param[out] name Returns a null terminated string containing the name of the uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glGetActiveUniform))(GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLsizei *size, GLenum *type, GLchar *name);

/**
 *  @brief Returns the handles of the shader objects attached to a program object
 *  @param[in] program Specifies the program object to be queried.
 *  @param[in] maxCount Specifies the size of the array for storing the returned object names.
 *  @param[out] count Returns the number of names actually returned in objects.
 *  @param[out] shaders Specifies an array that is used to return the names of attached shader objects.
 */
extern void (GLApi *GLFuncPtrName(glGetAttachedShaders))(GLuint program, GLsizei maxCount, GLsizei *count, GLuint *shaders);

/**
 *  @brief Returns the location of an attribute variable
 *  @param[in] program Specifies the program object to be queried.
 *  @param[in] name Points to a null terminated string containing the name of the attribute variable
 *      whose location is to be queried.
 */
extern int (GLApi *GLFuncPtrName(glGetAttribLocation))(GLuint program, const GLchar *name);

/**
 *  @brief Returns a parameter from a program object
 *  @param[in] program Specifies the program object to be queried.
 *  @param[in] pname Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS,
 *      GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS,
 *      GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS,
 *      GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH,
 *      GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE,
 *      GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH,
 *      GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
 *  @param[out] params Returns the requested object parameter.
 */
extern void (GLApi *GLFuncPtrName(glGetProgramiv))(GLuint program, GLenum pname, int *params);

/**
 *  @brief Returns the information log for a program object
 *  @param[in] program Specifies the program object whose information log is to be queried.
 *  @param[in] maxLength Specifies the size of the character buffer for storing the returned
 *      information log.
 *  @param[out] length Returns the length of the string returned in infoLog (excluding the null terminator).
 *  @param[out] infoLog Specifies an array of characters that is used to return the information log.
 */
extern void (GLApi *GLFuncPtrName(glGetProgramInfoLog))(GLuint program, GLsizei maxLength, GLsizei *length, GLchar *infoLog);

/**
 *  @brief Returns a parameter from a shader object
 *  @param[in] shader Specifies the shader object to be queried.
 *  @param[in] pname Specifies the object parameter. Accepted symbolic names are GL_SHADER_TYPE,
 *      GL_DELETE_STATUS, GL_COMPILE_STATUS, GL_INFO_LOG_LENGTH, GL_SHADER_SOURCE_LENGTH.
 *  @param[out] params Returns the requested object parameter.
 */
extern void (GLApi *GLFuncPtrName(glGetShaderiv))(GLuint shader, GLenum pname, int *params);

/**
 *  @brief Returns the information log for a shader object
 *  @param[in] shader Specifies the shader object whose information log is to be queried.
 *  @param[in] maxLength Specifies the size of the character buffer for storing the returned
 *      information log.
 *  @param[out] length Returns the length of the string returned in infoLog (excluding the null terminator).
 *  @param[out] infoLog Specifies an array of characters that is used to return the information log.
 */
extern void (GLApi *GLFuncPtrName(glGetShaderInfoLog))(GLuint shader, GLsizei maxLength, GLsizei *length, GLchar *infoLog);

/**
 *  @brief Replaces the source code in a shader object
 *  @param[in] shader Specifies the handle of the shader object whose source code is to be replaced.
 *  @param[in] count Specifies the number of elements in the string and length arrays.
 *  @param[in] string Specifies an array of pointers to strings containing the source code to be
 *      loaded into the shader.
 *  @param[in] length Specifies an array of string lengths.
 */
extern void (GLApi *GLFuncPtrName(glShaderSource))(GLuint shader, GLsizei count, const GLchar **string, const int *length);

/**
 *  @brief Returns the location of a uniform variable
 *  @param[in] program Specifies the program object to be queried.
 *  @param[in] name Points to a null terminated string containing the name of the uniform variable
 *      whose location is to be queried.
 */
extern int (GLApi *GLFuncPtrName(glGetUniformLocation))(GLuint program, const GLchar *name);

/**
 *  @brief Returns the value of a uniform variable
 *  @param[in] program Specifies the program object to be queried.
 *  @param[in] location Specifies the location of the uniform variable to be queried.
 *  @param[out] params Returns the value of the specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glGetUniformfv))(GLuint program, int location, float *params);

/**
 *  @brief Returns the value of a uniform variable
 *  @param[in] program Specifies the program object to be queried.
 *  @param[in] location Specifies the location of the uniform variable to be queried.
 *  @param[out] params Returns the value of the specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glGetUniformiv))(GLuint program, int location, int *params);

/**
 *  @brief Return a generic vertex attribute parameter
 *  @param[in] index Specifies the generic vertex attribute parameter to be queried.
 *  @param[in] pname Specifies the symbolic name of the vertex attribute parameter to be queried.
 *      Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED,
 *      GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE,
 *      GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER,
 *      GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
 *  @param[out] params Returns the requested data.
 */
extern void (GLApi *GLFuncPtrName(glGetVertexAttribdv))(GLuint index, GLenum pname, double *params);

/**
 *  @brief Return a generic vertex attribute parameter
 *  @param[in] index Specifies the generic vertex attribute parameter to be queried.
 *  @param[in] pname Specifies the symbolic name of the vertex attribute parameter to be queried.
 *      Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED,
 *      GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE,
 *      GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER,
 *      GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
 *  @param[out] params Returns the requested data.
 */
extern void (GLApi *GLFuncPtrName(glGetVertexAttribfv))(GLuint index, GLenum pname, float *params);

/**
 *  @brief Return a generic vertex attribute parameter
 *  @param[in] index Specifies the generic vertex attribute parameter to be queried.
 *  @param[in] pname Specifies the symbolic name of the vertex attribute parameter to be queried.
 *      Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED,
 *      GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE,
 *      GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER,
 *      GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
 *  @param[out] params Returns the requested data.
 */
extern void (GLApi *GLFuncPtrName(glGetVertexAttribiv))(GLuint index, GLenum pname, int *params);

/**
 *  @brief return the address of the specified generic vertex attribute pointer
 *  @param[in] index Specifies the generic vertex attribute parameter to be returned.
 *  @param[in] pname Specifies the symbolic name of the generic vertex attribute parameter to be
 *      returned. Must be GL_VERTEX_ATTRIB_ARRAY_POINTER.
 *  @param[out] pointer Returns the pointer value.
 */
extern void (GLApi *GLFuncPtrName(glGetVertexAttribPointerv))(GLuint index, GLenum pname, void **pointer);

/**
 *  @brief Determines if a name corresponds to a program object
 *  @param[in] program Specifies a potential program object.
 */
extern GLboolean (GLApi *GLFuncPtrName(glIsProgram))(GLuint program);

/**
 *  @brief Determines if a name corresponds to a shader object
 *  @param[in] shader Specifies a potential shader object.
 */
extern GLboolean (GLApi *GLFuncPtrName(glIsShader))(GLuint shader);

/**
 *  @brief Links a program object
 *  @param[in] program Specifies the handle of the program object to be linked.
 */
extern void (GLApi *GLFuncPtrName(glLinkProgram))(GLuint program);

/**
 *  @brief Returns the source code string from a shader object
 *  @param[in] shader Specifies the shader object to be queried.
 *  @param[in] bufSize Specifies the size of the character buffer for storing the returned source
 *      code string.
 *  @param[out] length Returns the length of the string returned in source (excluding the null terminator).
 *  @param[out] source Specifies an array of characters that is used to return the source code string.
 */
extern void (GLApi *GLFuncPtrName(glGetShaderSource))(GLuint shader, GLsizei bufSize, GLsizei *length, GLchar *source);

/**
 *  @brief Installs a program object as part of current rendering state
 *  @param[in] program Specifies the handle of the program object whose executables are to be used
 *      as part of current rendering state.
 */
extern void (GLApi *GLFuncPtrName(glUseProgram))(GLuint program);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform1f))(int location, float v0);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v1 Specifies the new values to be used for the specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform2f))(int location, float v0, float v1);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v1 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v2 Specifies the new values to be used for the specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform3f))(int location, float v0, float v1, float v2);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v1 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v2 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v3 Specifies the new values to be used for the specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform4f))(int location, float v0, float v1, float v2, float v3);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform1i))(int location, int v0);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v1 Specifies the new values to be used for the specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform2i))(int location, int v0, int v1);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v1 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v2 Specifies the new values to be used for the specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform3i))(int location, int v0, int v1, int v2);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v1 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v2 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v3 Specifies the new values to be used for the specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform4i))(int location, int v0, int v1, int v2, int v3);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform1fv))(int location, GLsizei count, const float *value);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform2fv))(int location, GLsizei count, const float *value);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform3fv))(int location, GLsizei count, const float *value);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform4fv))(int location, GLsizei count, const float *value);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform1iv))(int location, GLsizei count, const int *value);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform2iv))(int location, GLsizei count, const int *value);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform3iv))(int location, GLsizei count, const int *value);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniform4iv))(int location, GLsizei count, const int *value);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of matrices that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array of matrices, and 1 or more if it is an array
 *      of matrices.
 *  @param[in] transpose Specifies whether to transpose the matrix as the values are loaded into the
 *      uniform variable.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniformMatrix2fv))(int location, GLsizei count, GLboolean transpose, const float *value);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of matrices that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array of matrices, and 1 or more if it is an array
 *      of matrices.
 *  @param[in] transpose Specifies whether to transpose the matrix as the values are loaded into the
 *      uniform variable.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniformMatrix3fv))(int location, GLsizei count, GLboolean transpose, const float *value);

/**
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of matrices that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array of matrices, and 1 or more if it is an array
 *      of matrices.
 *  @param[in] transpose Specifies whether to transpose the matrix as the values are loaded into the
 *      uniform variable.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
extern void (GLApi *GLFuncPtrName(glUniformMatrix4fv))(int location, GLsizei count, GLboolean transpose, const float *value);

/**
 *  @brief Validates a program object
 *  @param[in] program Specifies the handle of the program object to be validated.
 */
extern void (GLApi *GLFuncPtrName(glValidateProgram))(GLuint program);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib1d))(GLuint index, double v0);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib1dv))(GLuint index, const double *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib1f))(GLuint index, float v0);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib1fv))(GLuint index, const float *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib1s))(GLuint index, short v0);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib1sv))(GLuint index, const short *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib2d))(GLuint index, double v0, double v1);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib2dv))(GLuint index, const double *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib2f))(GLuint index, float v0, float v1);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib2fv))(GLuint index, const float *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib2s))(GLuint index, short v0, short v1);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib2sv))(GLuint index, const short *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib3d))(GLuint index, double v0, double v1, double v2);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib3dv))(GLuint index, const double *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib3f))(GLuint index, float v0, float v1, float v2);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib3fv))(GLuint index, const float *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib3s))(GLuint index, short v0, short v1, short v2);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib3sv))(GLuint index, const short *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib4Nbv))(GLuint index, const GLbyte *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib4Niv))(GLuint index, const int *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib4Nsv))(GLuint index, const short *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v3 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib4Nub))(GLuint index, GLubyte v0, GLubyte v1, GLubyte v2, GLubyte v3);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib4Nubv))(GLuint index, const GLubyte *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib4Nuiv))(GLuint index, const GLuint *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib4Nusv))(GLuint index, const GLushort *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib4bv))(GLuint index, const GLbyte *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v3 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib4d))(GLuint index, double v0, double v1, double v2, double v3);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib4dv))(GLuint index, const double *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v3 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib4f))(GLuint index, float v0, float v1, float v2, float v3);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib4fv))(GLuint index, const float *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib4iv))(GLuint index, const int *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v3 Specifies the new values to be used for the specified vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib4s))(GLuint index, short v0, short v1, short v2, short v3);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib4sv))(GLuint index, const short *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib4ubv))(GLuint index, const GLubyte *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib4uiv))(GLuint index, const GLuint *v);

/**
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttrib4usv))(GLuint index, const GLushort *v);

/**
 *  @brief define an array of generic vertex attribute data
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] size Specifies the number of components per generic vertex attribute. Must be 1, 2,
 *      3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The
 *      initial value is 4.
 *  @param[in] type Specifies the data type of each component in the array. The symbolic constants
 *      GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are
 *      accepted by both functions. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED,
 *      GL_INT_2_10_10_10_REV, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted by
 *      glVertexAttribPointer. The initial value is GL_FLOAT.
 *  @param[in] normalized For glVertexAttribPointer , specifies whether fixed-point data values
 *      should be normalized ( GL_TRUE ) or converted directly as fixed-point values ( GL_FALSE)
 *      when they are accessed.
 *  @param[in] stride Specifies the byte offset between consecutive generic vertex attributes. If
 *      stride is 0, the generic vertex attributes are understood to be tightly packed in the array.
 *      The initial value is 0.
 *  @param[in] pointer Specifies a offset of the first component of the first generic vertex
 *      attribute in the array in the data store of the buffer currently bound to the
 *      GL_ARRAY_BUFFER target. The initial value is 0.
 */
extern void (GLApi *GLFuncPtrName(glVertexAttribPointer))(GLuint index, int size, GLenum type, GLboolean normalized, GLsizei stride, const void *pointer);

inline GLuint glCreateProgram_glachwrap(const char *p_s_filename, int n_line) { GLuint result = GLFuncPtrName(glCreateProgram)(); GL_AUTOCHECK_BLOCK("glCreateProgram", p_s_filename, n_line); return result; }
inline GLuint glCreateShader_glachwrap(GLenum shaderType, const char *p_s_filename, int n_line) { GLuint result = GLFuncPtrName(glCreateShader)(shaderType); GL_AUTOCHECK_BLOCK("glCreateShader", p_s_filename, n_line); return result; }
inline int glGetAttribLocation_glachwrap(GLuint program, const GLchar *name, const char *p_s_filename, int n_line) { int result = GLFuncPtrName(glGetAttribLocation)(program,name); GL_AUTOCHECK_BLOCK("glGetAttribLocation", p_s_filename, n_line); return result; }
inline int glGetUniformLocation_glachwrap(GLuint program, const GLchar *name, const char *p_s_filename, int n_line) { int result = GLFuncPtrName(glGetUniformLocation)(program,name); GL_AUTOCHECK_BLOCK("glGetUniformLocation", p_s_filename, n_line); return result; }
inline GLboolean glIsProgram_glachwrap(GLuint program, const char *p_s_filename, int n_line) { GLboolean result = GLFuncPtrName(glIsProgram)(program); GL_AUTOCHECK_BLOCK("glIsProgram", p_s_filename, n_line); return result; }
inline GLboolean glIsShader_glachwrap(GLuint shader, const char *p_s_filename, int n_line) { GLboolean result = GLFuncPtrName(glIsShader)(shader); GL_AUTOCHECK_BLOCK("glIsShader", p_s_filename, n_line); return result; }

/**
 *  @def glBlendEquationSeparate
 *  @brief set the RGB blend equation and the alpha blend equation separately
 *  @param[in] modeRGB specifies the RGB blend equation, how the red, green, and blue components of
 *      the source and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT,
 *      GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
 *  @param[in] modeAlpha specifies the alpha blend equation, how the alpha component of the source
 *      and destination colors are combined. It must be GL_FUNC_ADD, GL_FUNC_SUBTRACT,
 *      GL_FUNC_REVERSE_SUBTRACT, GL_MIN, GL_MAX.
 */
#define glBlendEquationSeparate(modeRGB,modeAlpha) do { GLFuncPtrName(glBlendEquationSeparate)(modeRGB, modeAlpha); GL_AUTOCHECK_BLOCK("glBlendEquationSeparate", __FILE__, __LINE__); } while(0)

/**
 *  @def glDrawBuffers
 *  @brief Specifies a list of color buffers to be drawn into
 *  @param[in] n Specifies the number of buffers in bufs.
 *  @param[in] bufs Points to an array of symbolic constants specifying the buffers into which
 *      fragment colors or data values will be written.
 */
#define glDrawBuffers(n,bufs) do { GLFuncPtrName(glDrawBuffers)(n, bufs); GL_AUTOCHECK_BLOCK("glDrawBuffers", __FILE__, __LINE__); } while(0)

/**
 *  @def glStencilOpSeparate
 *  @brief set front and/or back stencil test actions
 *  @param[in] face Specifies whether front and/or back stencil state is updated. Three symbolic
 *      constants are valid: GL_FRONT, GL_BACK, and GL_FRONT_AND_BACK.
 *  @param[in] sfail Specifies the action to take when the stencil test fails. Eight symbolic
 *      constants are accepted: GL_KEEP, GL_ZERO, GL_REPLACE, GL_INCR, GL_INCR_WRAP, GL_DECR,
 *      GL_DECR_WRAP, and GL_INVERT. The initial value is GL_KEEP.
 *  @param[in] dpfail Specifies the stencil action when the stencil test passes, but the depth test
 *      fails. dpfail accepts the same symbolic constants as sfail. The initial value is GL_KEEP.
 *  @param[in] dppass Specifies the stencil action when both the stencil test and the depth test
 *      pass, or when the stencil test passes and either there is no depth buffer or depth testing
 *      is not enabled. dppass accepts the same symbolic constants as sfail. The initial value is GL_KEEP.
 */
#define glStencilOpSeparate(face,sfail,dpfail,dppass) do { GLFuncPtrName(glStencilOpSeparate)(face, sfail, dpfail, dppass); GL_AUTOCHECK_BLOCK("glStencilOpSeparate", __FILE__, __LINE__); } while(0)

/**
 *  @def glStencilFuncSeparate
 *  @brief set front and/or back function and reference value for stencil testing
 *  @param[in] face Specifies whether front and/or back stencil state is updated. Three symbolic
 *      constants are valid: GL_FRONT, GL_BACK, and GL_FRONT_AND_BACK.
 *  @param[in] func Specifies the test function. Eight symbolic constants are valid: GL_NEVER,
 *      GL_LESS, GL_LEQUAL, GL_GREATER, GL_GEQUAL, GL_EQUAL, GL_NOTEQUAL, and GL_ALWAYS. The initial
 *      value is GL_ALWAYS.
 *  @param[in] ref Specifies the reference value for the stencil test. ref is clamped to the range 0
 *      2 n - 1, where n is the number of bitplanes in the stencil buffer. The initial value is 0.
 *  @param[in] mask Specifies a mask that is ANDed with both the reference value and the stored
 *      stencil value when the test is done. The initial value is all 1's.
 */
#define glStencilFuncSeparate(face,func,ref,mask) do { GLFuncPtrName(glStencilFuncSeparate)(face, func, ref, mask); GL_AUTOCHECK_BLOCK("glStencilFuncSeparate", __FILE__, __LINE__); } while(0)

/**
 *  @def glStencilMaskSeparate
 *  @brief control the front and/or back writing of individual bits in the stencil planes
 *  @param[in] face Specifies whether the front and/or back stencil writemask is updated. Three
 *      symbolic constants are valid: GL_FRONT, GL_BACK, and GL_FRONT_AND_BACK.
 *  @param[in] mask Specifies a bit mask to enable and disable writing of individual bits in the
 *      stencil planes. Initially, the mask is all 1's.
 */
#define glStencilMaskSeparate(face,mask) do { GLFuncPtrName(glStencilMaskSeparate)(face, mask); GL_AUTOCHECK_BLOCK("glStencilMaskSeparate", __FILE__, __LINE__); } while(0)

/**
 *  @def glAttachShader
 *  @brief Attaches a shader object to a program object
 *  @param[in] program Specifies the program object to which a shader object will be attached.
 *  @param[in] shader Specifies the shader object that is to be attached.
 */
#define glAttachShader(program,shader) do { GLFuncPtrName(glAttachShader)(program, shader); GL_AUTOCHECK_BLOCK("glAttachShader", __FILE__, __LINE__); } while(0)

/**
 *  @def glBindAttribLocation
 *  @brief Associates a generic vertex attribute index with a named attribute variable
 *  @param[in] program Specifies the handle of the program object in which the association is to be made.
 *  @param[in] index Specifies the index of the generic vertex attribute to be bound.
 *  @param[in] name Specifies a null terminated string containing the name of the vertex shader
 *      attribute variable to which index is to be bound.
 */
#define glBindAttribLocation(program,index,name) do { GLFuncPtrName(glBindAttribLocation)(program, index, name); GL_AUTOCHECK_BLOCK("glBindAttribLocation", __FILE__, __LINE__); } while(0)

/**
 *  @def glCompileShader
 *  @brief Compiles a shader object
 *  @param[in] shader Specifies the shader object to be compiled.
 */
#define glCompileShader(shader) do { GLFuncPtrName(glCompileShader)(shader); GL_AUTOCHECK_BLOCK("glCompileShader", __FILE__, __LINE__); } while(0)

/**
 *  @def glCreateProgram
 *  @brief Creates a program object
 */
#define glCreateProgram() GLAutoCheckFuncPtrName(glCreateProgram)(GLAutoCheckExtraParamsSA)

/**
 *  @def glCreateShader
 *  @brief Creates a shader object
 *  @param[in] shaderType Specifies the type of shader to be created. Must be one of
 *      GL_VERTEX_SHADER, GL_TESS_CONTROL_SHADER, GL_TESS_EVALUATION_SHADER, GL_GEOMETRY_SHADER, or GL_FRAGMENT_SHADER.
 */
#define glCreateShader(shaderType) GLAutoCheckFuncPtrName(glCreateShader)(shaderType GLAutoCheckExtraParams)

/**
 *  @def glDeleteProgram
 *  @brief Deletes a program object
 *  @param[in] program Specifies the program object to be deleted.
 */
#define glDeleteProgram(program) do { GLFuncPtrName(glDeleteProgram)(program); GL_AUTOCHECK_BLOCK("glDeleteProgram", __FILE__, __LINE__); } while(0)

/**
 *  @def glDeleteShader
 *  @brief Deletes a shader object
 *  @param[in] shader Specifies the shader object to be deleted.
 */
#define glDeleteShader(shader) do { GLFuncPtrName(glDeleteShader)(shader); GL_AUTOCHECK_BLOCK("glDeleteShader", __FILE__, __LINE__); } while(0)

/**
 *  @def glDetachShader
 *  @brief Detaches a shader object from a program object to which it is attached
 *  @param[in] program Specifies the program object from which to detach the shader object.
 *  @param[in] shader Specifies the shader object to be detached.
 */
#define glDetachShader(program,shader) do { GLFuncPtrName(glDetachShader)(program, shader); GL_AUTOCHECK_BLOCK("glDetachShader", __FILE__, __LINE__); } while(0)

/**
 *  @def glDisableVertexAttribArray
 *  @brief Enable or disable a generic vertex attribute array
 *  @param[in] index Specifies the index of the generic vertex attribute to be enabled or disabled.
 */
#define glDisableVertexAttribArray(index) do { GLFuncPtrName(glDisableVertexAttribArray)(index); GL_AUTOCHECK_BLOCK("glDisableVertexAttribArray", __FILE__, __LINE__); } while(0)

/**
 *  @def glEnableVertexAttribArray
 *  @brief Enable or disable a generic vertex attribute array
 *  @param[in] index Specifies the index of the generic vertex attribute to be enabled or disabled.
 */
#define glEnableVertexAttribArray(index) do { GLFuncPtrName(glEnableVertexAttribArray)(index); GL_AUTOCHECK_BLOCK("glEnableVertexAttribArray", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetActiveAttrib
 *  @brief Returns information about an active attribute variable for the specified program object
 *  @param[in] program Specifies the program object to be queried.
 *  @param[in] index Specifies the index of the attribute variable to be queried.
 *  @param[in] bufSize Specifies the maximum number of characters OpenGL is allowed to write in the
 *      character buffer indicated by name.
 *  @param[out] length Returns the number of characters actually written by OpenGL in the string
 *      indicated by name (excluding the null terminator) if a value other than NULL is passed.
 *  @param[out] size Returns the size of the attribute variable.
 *  @param[out] type Returns the data type of the attribute variable.
 *  @param[out] name Returns a null terminated string containing the name of the attribute variable.
 */
#define glGetActiveAttrib(program,index,bufSize,length,size,type,name) do { GLFuncPtrName(glGetActiveAttrib)(program, index, bufSize, length, size, type, name); GL_AUTOCHECK_BLOCK("glGetActiveAttrib", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetActiveUniform
 *  @brief Returns information about an active uniform variable for the specified program object
 *  @param[in] program Specifies the program object to be queried.
 *  @param[in] index Specifies the index of the uniform variable to be queried.
 *  @param[in] bufSize Specifies the maximum number of characters OpenGL is allowed to write in the
 *      character buffer indicated by name.
 *  @param[out] length Returns the number of characters actually written by OpenGL in the string
 *      indicated by name (excluding the null terminator) if a value other than NULL is passed.
 *  @param[out] size Returns the size of the uniform variable.
 *  @param[out] type Returns the data type of the uniform variable.
 *  @param[out] name Returns a null terminated string containing the name of the uniform variable.
 */
#define glGetActiveUniform(program,index,bufSize,length,size,type,name) do { GLFuncPtrName(glGetActiveUniform)(program, index, bufSize, length, size, type, name); GL_AUTOCHECK_BLOCK("glGetActiveUniform", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetAttachedShaders
 *  @brief Returns the handles of the shader objects attached to a program object
 *  @param[in] program Specifies the program object to be queried.
 *  @param[in] maxCount Specifies the size of the array for storing the returned object names.
 *  @param[out] count Returns the number of names actually returned in objects.
 *  @param[out] shaders Specifies an array that is used to return the names of attached shader objects.
 */
#define glGetAttachedShaders(program,maxCount,count,shaders) do { GLFuncPtrName(glGetAttachedShaders)(program, maxCount, count, shaders); GL_AUTOCHECK_BLOCK("glGetAttachedShaders", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetAttribLocation
 *  @brief Returns the location of an attribute variable
 *  @param[in] program Specifies the program object to be queried.
 *  @param[in] name Points to a null terminated string containing the name of the attribute variable
 *      whose location is to be queried.
 */
#define glGetAttribLocation(program,name) GLAutoCheckFuncPtrName(glGetAttribLocation)(program, name GLAutoCheckExtraParams)

/**
 *  @def glGetProgramiv
 *  @brief Returns a parameter from a program object
 *  @param[in] program Specifies the program object to be queried.
 *  @param[in] pname Specifies the object parameter. Accepted symbolic names are GL_DELETE_STATUS,
 *      GL_LINK_STATUS, GL_VALIDATE_STATUS, GL_INFO_LOG_LENGTH, GL_ATTACHED_SHADERS,
 *      GL_ACTIVE_ATTRIBUTES, GL_ACTIVE_ATTRIBUTE_MAX_LENGTH, GL_ACTIVE_UNIFORMS,
 *      GL_ACTIVE_UNIFORM_BLOCKS, GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH,
 *      GL_ACTIVE_UNIFORM_MAX_LENGTH, GL_PROGRAM_BINARY_LENGTH, GL_TRANSFORM_FEEDBACK_BUFFER_MODE,
 *      GL_TRANSFORM_FEEDBACK_VARYINGS, GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH,
 *      GL_GEOMETRY_VERTICES_OUT, GL_GEOMETRY_INPUT_TYPE, and GL_GEOMETRY_OUTPUT_TYPE.
 *  @param[out] params Returns the requested object parameter.
 */
#define glGetProgramiv(program,pname,params) do { GLFuncPtrName(glGetProgramiv)(program, pname, params); GL_AUTOCHECK_BLOCK("glGetProgramiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetProgramInfoLog
 *  @brief Returns the information log for a program object
 *  @param[in] program Specifies the program object whose information log is to be queried.
 *  @param[in] maxLength Specifies the size of the character buffer for storing the returned
 *      information log.
 *  @param[out] length Returns the length of the string returned in infoLog (excluding the null terminator).
 *  @param[out] infoLog Specifies an array of characters that is used to return the information log.
 */
#define glGetProgramInfoLog(program,maxLength,length,infoLog) do { GLFuncPtrName(glGetProgramInfoLog)(program, maxLength, length, infoLog); GL_AUTOCHECK_BLOCK("glGetProgramInfoLog", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetShaderiv
 *  @brief Returns a parameter from a shader object
 *  @param[in] shader Specifies the shader object to be queried.
 *  @param[in] pname Specifies the object parameter. Accepted symbolic names are GL_SHADER_TYPE,
 *      GL_DELETE_STATUS, GL_COMPILE_STATUS, GL_INFO_LOG_LENGTH, GL_SHADER_SOURCE_LENGTH.
 *  @param[out] params Returns the requested object parameter.
 */
#define glGetShaderiv(shader,pname,params) do { GLFuncPtrName(glGetShaderiv)(shader, pname, params); GL_AUTOCHECK_BLOCK("glGetShaderiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetShaderInfoLog
 *  @brief Returns the information log for a shader object
 *  @param[in] shader Specifies the shader object whose information log is to be queried.
 *  @param[in] maxLength Specifies the size of the character buffer for storing the returned
 *      information log.
 *  @param[out] length Returns the length of the string returned in infoLog (excluding the null terminator).
 *  @param[out] infoLog Specifies an array of characters that is used to return the information log.
 */
#define glGetShaderInfoLog(shader,maxLength,length,infoLog) do { GLFuncPtrName(glGetShaderInfoLog)(shader, maxLength, length, infoLog); GL_AUTOCHECK_BLOCK("glGetShaderInfoLog", __FILE__, __LINE__); } while(0)

/**
 *  @def glShaderSource
 *  @brief Replaces the source code in a shader object
 *  @param[in] shader Specifies the handle of the shader object whose source code is to be replaced.
 *  @param[in] count Specifies the number of elements in the string and length arrays.
 *  @param[in] string Specifies an array of pointers to strings containing the source code to be
 *      loaded into the shader.
 *  @param[in] length Specifies an array of string lengths.
 */
#define glShaderSource(shader,count,string,length) do { GLFuncPtrName(glShaderSource)(shader, count, string, length); GL_AUTOCHECK_BLOCK("glShaderSource", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetUniformLocation
 *  @brief Returns the location of a uniform variable
 *  @param[in] program Specifies the program object to be queried.
 *  @param[in] name Points to a null terminated string containing the name of the uniform variable
 *      whose location is to be queried.
 */
#define glGetUniformLocation(program,name) GLAutoCheckFuncPtrName(glGetUniformLocation)(program, name GLAutoCheckExtraParams)

/**
 *  @def glGetUniformfv
 *  @brief Returns the value of a uniform variable
 *  @param[in] program Specifies the program object to be queried.
 *  @param[in] location Specifies the location of the uniform variable to be queried.
 *  @param[out] params Returns the value of the specified uniform variable.
 */
#define glGetUniformfv(program,location,params) do { GLFuncPtrName(glGetUniformfv)(program, location, params); GL_AUTOCHECK_BLOCK("glGetUniformfv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetUniformiv
 *  @brief Returns the value of a uniform variable
 *  @param[in] program Specifies the program object to be queried.
 *  @param[in] location Specifies the location of the uniform variable to be queried.
 *  @param[out] params Returns the value of the specified uniform variable.
 */
#define glGetUniformiv(program,location,params) do { GLFuncPtrName(glGetUniformiv)(program, location, params); GL_AUTOCHECK_BLOCK("glGetUniformiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetVertexAttribdv
 *  @brief Return a generic vertex attribute parameter
 *  @param[in] index Specifies the generic vertex attribute parameter to be queried.
 *  @param[in] pname Specifies the symbolic name of the vertex attribute parameter to be queried.
 *      Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED,
 *      GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE,
 *      GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER,
 *      GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
 *  @param[out] params Returns the requested data.
 */
#define glGetVertexAttribdv(index,pname,params) do { GLFuncPtrName(glGetVertexAttribdv)(index, pname, params); GL_AUTOCHECK_BLOCK("glGetVertexAttribdv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetVertexAttribfv
 *  @brief Return a generic vertex attribute parameter
 *  @param[in] index Specifies the generic vertex attribute parameter to be queried.
 *  @param[in] pname Specifies the symbolic name of the vertex attribute parameter to be queried.
 *      Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED,
 *      GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE,
 *      GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER,
 *      GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
 *  @param[out] params Returns the requested data.
 */
#define glGetVertexAttribfv(index,pname,params) do { GLFuncPtrName(glGetVertexAttribfv)(index, pname, params); GL_AUTOCHECK_BLOCK("glGetVertexAttribfv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetVertexAttribiv
 *  @brief Return a generic vertex attribute parameter
 *  @param[in] index Specifies the generic vertex attribute parameter to be queried.
 *  @param[in] pname Specifies the symbolic name of the vertex attribute parameter to be queried.
 *      Accepted values are GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, GL_VERTEX_ATTRIB_ARRAY_ENABLED,
 *      GL_VERTEX_ATTRIB_ARRAY_SIZE, GL_VERTEX_ATTRIB_ARRAY_STRIDE, GL_VERTEX_ATTRIB_ARRAY_TYPE,
 *      GL_VERTEX_ATTRIB_ARRAY_NORMALIZED, GL_VERTEX_ATTRIB_ARRAY_INTEGER,
 *      GL_VERTEX_ATTRIB_ARRAY_DIVISOR, or GL_CURRENT_VERTEX_ATTRIB.
 *  @param[out] params Returns the requested data.
 */
#define glGetVertexAttribiv(index,pname,params) do { GLFuncPtrName(glGetVertexAttribiv)(index, pname, params); GL_AUTOCHECK_BLOCK("glGetVertexAttribiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetVertexAttribPointerv
 *  @brief return the address of the specified generic vertex attribute pointer
 *  @param[in] index Specifies the generic vertex attribute parameter to be returned.
 *  @param[in] pname Specifies the symbolic name of the generic vertex attribute parameter to be
 *      returned. Must be GL_VERTEX_ATTRIB_ARRAY_POINTER.
 *  @param[out] pointer Returns the pointer value.
 */
#define glGetVertexAttribPointerv(index,pname,pointer) do { GLFuncPtrName(glGetVertexAttribPointerv)(index, pname, pointer); GL_AUTOCHECK_BLOCK("glGetVertexAttribPointerv", __FILE__, __LINE__); } while(0)

/**
 *  @def glIsProgram
 *  @brief Determines if a name corresponds to a program object
 *  @param[in] program Specifies a potential program object.
 */
#define glIsProgram(program) GLAutoCheckFuncPtrName(glIsProgram)(program GLAutoCheckExtraParams)

/**
 *  @def glIsShader
 *  @brief Determines if a name corresponds to a shader object
 *  @param[in] shader Specifies a potential shader object.
 */
#define glIsShader(shader) GLAutoCheckFuncPtrName(glIsShader)(shader GLAutoCheckExtraParams)

/**
 *  @def glLinkProgram
 *  @brief Links a program object
 *  @param[in] program Specifies the handle of the program object to be linked.
 */
#define glLinkProgram(program) do { GLFuncPtrName(glLinkProgram)(program); GL_AUTOCHECK_BLOCK("glLinkProgram", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetShaderSource
 *  @brief Returns the source code string from a shader object
 *  @param[in] shader Specifies the shader object to be queried.
 *  @param[in] bufSize Specifies the size of the character buffer for storing the returned source
 *      code string.
 *  @param[out] length Returns the length of the string returned in source (excluding the null terminator).
 *  @param[out] source Specifies an array of characters that is used to return the source code string.
 */
#define glGetShaderSource(shader,bufSize,length,source) do { GLFuncPtrName(glGetShaderSource)(shader, bufSize, length, source); GL_AUTOCHECK_BLOCK("glGetShaderSource", __FILE__, __LINE__); } while(0)

/**
 *  @def glUseProgram
 *  @brief Installs a program object as part of current rendering state
 *  @param[in] program Specifies the handle of the program object whose executables are to be used
 *      as part of current rendering state.
 */
#define glUseProgram(program) do { GLFuncPtrName(glUseProgram)(program); GL_AUTOCHECK_BLOCK("glUseProgram", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform1f
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 */
#define glUniform1f(location,v0) do { GLFuncPtrName(glUniform1f)(location, v0); GL_AUTOCHECK_BLOCK("glUniform1f", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform2f
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v1 Specifies the new values to be used for the specified uniform variable.
 */
#define glUniform2f(location,v0,v1) do { GLFuncPtrName(glUniform2f)(location, v0, v1); GL_AUTOCHECK_BLOCK("glUniform2f", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform3f
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v1 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v2 Specifies the new values to be used for the specified uniform variable.
 */
#define glUniform3f(location,v0,v1,v2) do { GLFuncPtrName(glUniform3f)(location, v0, v1, v2); GL_AUTOCHECK_BLOCK("glUniform3f", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform4f
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v1 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v2 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v3 Specifies the new values to be used for the specified uniform variable.
 */
#define glUniform4f(location,v0,v1,v2,v3) do { GLFuncPtrName(glUniform4f)(location, v0, v1, v2, v3); GL_AUTOCHECK_BLOCK("glUniform4f", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform1i
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 */
#define glUniform1i(location,v0) do { GLFuncPtrName(glUniform1i)(location, v0); GL_AUTOCHECK_BLOCK("glUniform1i", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform2i
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v1 Specifies the new values to be used for the specified uniform variable.
 */
#define glUniform2i(location,v0,v1) do { GLFuncPtrName(glUniform2i)(location, v0, v1); GL_AUTOCHECK_BLOCK("glUniform2i", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform3i
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v1 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v2 Specifies the new values to be used for the specified uniform variable.
 */
#define glUniform3i(location,v0,v1,v2) do { GLFuncPtrName(glUniform3i)(location, v0, v1, v2); GL_AUTOCHECK_BLOCK("glUniform3i", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform4i
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform variable to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v1 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v2 Specifies the new values to be used for the specified uniform variable.
 *  @param[in] v3 Specifies the new values to be used for the specified uniform variable.
 */
#define glUniform4i(location,v0,v1,v2,v3) do { GLFuncPtrName(glUniform4i)(location, v0, v1, v2, v3); GL_AUTOCHECK_BLOCK("glUniform4i", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform1fv
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
#define glUniform1fv(location,count,value) do { GLFuncPtrName(glUniform1fv)(location, count, value); GL_AUTOCHECK_BLOCK("glUniform1fv", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform2fv
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
#define glUniform2fv(location,count,value) do { GLFuncPtrName(glUniform2fv)(location, count, value); GL_AUTOCHECK_BLOCK("glUniform2fv", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform3fv
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
#define glUniform3fv(location,count,value) do { GLFuncPtrName(glUniform3fv)(location, count, value); GL_AUTOCHECK_BLOCK("glUniform3fv", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform4fv
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
#define glUniform4fv(location,count,value) do { GLFuncPtrName(glUniform4fv)(location, count, value); GL_AUTOCHECK_BLOCK("glUniform4fv", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform1iv
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
#define glUniform1iv(location,count,value) do { GLFuncPtrName(glUniform1iv)(location, count, value); GL_AUTOCHECK_BLOCK("glUniform1iv", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform2iv
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
#define glUniform2iv(location,count,value) do { GLFuncPtrName(glUniform2iv)(location, count, value); GL_AUTOCHECK_BLOCK("glUniform2iv", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform3iv
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
#define glUniform3iv(location,count,value) do { GLFuncPtrName(glUniform3iv)(location, count, value); GL_AUTOCHECK_BLOCK("glUniform3iv", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniform4iv
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of elements that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array, and 1 or more if it is an array.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
#define glUniform4iv(location,count,value) do { GLFuncPtrName(glUniform4iv)(location, count, value); GL_AUTOCHECK_BLOCK("glUniform4iv", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniformMatrix2fv
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of matrices that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array of matrices, and 1 or more if it is an array
 *      of matrices.
 *  @param[in] transpose Specifies whether to transpose the matrix as the values are loaded into the
 *      uniform variable.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
#define glUniformMatrix2fv(location,count,transpose,value) do { GLFuncPtrName(glUniformMatrix2fv)(location, count, transpose, value); GL_AUTOCHECK_BLOCK("glUniformMatrix2fv", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniformMatrix3fv
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of matrices that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array of matrices, and 1 or more if it is an array
 *      of matrices.
 *  @param[in] transpose Specifies whether to transpose the matrix as the values are loaded into the
 *      uniform variable.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
#define glUniformMatrix3fv(location,count,transpose,value) do { GLFuncPtrName(glUniformMatrix3fv)(location, count, transpose, value); GL_AUTOCHECK_BLOCK("glUniformMatrix3fv", __FILE__, __LINE__); } while(0)

/**
 *  @def glUniformMatrix4fv
 *  @brief Specify the value of a uniform variable for the current program object
 *  @param[in] location Specifies the location of the uniform value to be modified.
 *  @param[in] count Specifies the number of matrices that are to be modified. This should be 1 if
 *      the targeted uniform variable is not an array of matrices, and 1 or more if it is an array
 *      of matrices.
 *  @param[in] transpose Specifies whether to transpose the matrix as the values are loaded into the
 *      uniform variable.
 *  @param[in] value Specifies a pointer to an array of count values that will be used to update the
 *      specified uniform variable.
 */
#define glUniformMatrix4fv(location,count,transpose,value) do { GLFuncPtrName(glUniformMatrix4fv)(location, count, transpose, value); GL_AUTOCHECK_BLOCK("glUniformMatrix4fv", __FILE__, __LINE__); } while(0)

/**
 *  @def glValidateProgram
 *  @brief Validates a program object
 *  @param[in] program Specifies the handle of the program object to be validated.
 */
#define glValidateProgram(program) do { GLFuncPtrName(glValidateProgram)(program); GL_AUTOCHECK_BLOCK("glValidateProgram", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib1d
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttrib1d(index,v0) do { GLFuncPtrName(glVertexAttrib1d)(index, v0); GL_AUTOCHECK_BLOCK("glVertexAttrib1d", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib1dv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib1dv(index,v) do { GLFuncPtrName(glVertexAttrib1dv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib1dv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib1f
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttrib1f(index,v0) do { GLFuncPtrName(glVertexAttrib1f)(index, v0); GL_AUTOCHECK_BLOCK("glVertexAttrib1f", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib1fv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib1fv(index,v) do { GLFuncPtrName(glVertexAttrib1fv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib1fv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib1s
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttrib1s(index,v0) do { GLFuncPtrName(glVertexAttrib1s)(index, v0); GL_AUTOCHECK_BLOCK("glVertexAttrib1s", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib1sv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib1sv(index,v) do { GLFuncPtrName(glVertexAttrib1sv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib1sv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib2d
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttrib2d(index,v0,v1) do { GLFuncPtrName(glVertexAttrib2d)(index, v0, v1); GL_AUTOCHECK_BLOCK("glVertexAttrib2d", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib2dv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib2dv(index,v) do { GLFuncPtrName(glVertexAttrib2dv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib2dv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib2f
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttrib2f(index,v0,v1) do { GLFuncPtrName(glVertexAttrib2f)(index, v0, v1); GL_AUTOCHECK_BLOCK("glVertexAttrib2f", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib2fv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib2fv(index,v) do { GLFuncPtrName(glVertexAttrib2fv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib2fv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib2s
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttrib2s(index,v0,v1) do { GLFuncPtrName(glVertexAttrib2s)(index, v0, v1); GL_AUTOCHECK_BLOCK("glVertexAttrib2s", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib2sv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib2sv(index,v) do { GLFuncPtrName(glVertexAttrib2sv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib2sv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib3d
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttrib3d(index,v0,v1,v2) do { GLFuncPtrName(glVertexAttrib3d)(index, v0, v1, v2); GL_AUTOCHECK_BLOCK("glVertexAttrib3d", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib3dv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib3dv(index,v) do { GLFuncPtrName(glVertexAttrib3dv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib3dv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib3f
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttrib3f(index,v0,v1,v2) do { GLFuncPtrName(glVertexAttrib3f)(index, v0, v1, v2); GL_AUTOCHECK_BLOCK("glVertexAttrib3f", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib3fv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib3fv(index,v) do { GLFuncPtrName(glVertexAttrib3fv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib3fv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib3s
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttrib3s(index,v0,v1,v2) do { GLFuncPtrName(glVertexAttrib3s)(index, v0, v1, v2); GL_AUTOCHECK_BLOCK("glVertexAttrib3s", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib3sv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib3sv(index,v) do { GLFuncPtrName(glVertexAttrib3sv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib3sv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib4Nbv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib4Nbv(index,v) do { GLFuncPtrName(glVertexAttrib4Nbv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib4Nbv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib4Niv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib4Niv(index,v) do { GLFuncPtrName(glVertexAttrib4Niv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib4Niv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib4Nsv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib4Nsv(index,v) do { GLFuncPtrName(glVertexAttrib4Nsv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib4Nsv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib4Nub
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v3 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttrib4Nub(index,v0,v1,v2,v3) do { GLFuncPtrName(glVertexAttrib4Nub)(index, v0, v1, v2, v3); GL_AUTOCHECK_BLOCK("glVertexAttrib4Nub", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib4Nubv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib4Nubv(index,v) do { GLFuncPtrName(glVertexAttrib4Nubv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib4Nubv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib4Nuiv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib4Nuiv(index,v) do { GLFuncPtrName(glVertexAttrib4Nuiv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib4Nuiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib4Nusv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib4Nusv(index,v) do { GLFuncPtrName(glVertexAttrib4Nusv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib4Nusv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib4bv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib4bv(index,v) do { GLFuncPtrName(glVertexAttrib4bv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib4bv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib4d
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v3 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttrib4d(index,v0,v1,v2,v3) do { GLFuncPtrName(glVertexAttrib4d)(index, v0, v1, v2, v3); GL_AUTOCHECK_BLOCK("glVertexAttrib4d", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib4dv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib4dv(index,v) do { GLFuncPtrName(glVertexAttrib4dv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib4dv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib4f
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v3 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttrib4f(index,v0,v1,v2,v3) do { GLFuncPtrName(glVertexAttrib4f)(index, v0, v1, v2, v3); GL_AUTOCHECK_BLOCK("glVertexAttrib4f", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib4fv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib4fv(index,v) do { GLFuncPtrName(glVertexAttrib4fv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib4fv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib4iv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib4iv(index,v) do { GLFuncPtrName(glVertexAttrib4iv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib4iv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib4s
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v0 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v1 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v2 Specifies the new values to be used for the specified vertex attribute.
 *  @param[in] v3 Specifies the new values to be used for the specified vertex attribute.
 */
#define glVertexAttrib4s(index,v0,v1,v2,v3) do { GLFuncPtrName(glVertexAttrib4s)(index, v0, v1, v2, v3); GL_AUTOCHECK_BLOCK("glVertexAttrib4s", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib4sv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib4sv(index,v) do { GLFuncPtrName(glVertexAttrib4sv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib4sv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib4ubv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib4ubv(index,v) do { GLFuncPtrName(glVertexAttrib4ubv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib4ubv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib4uiv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib4uiv(index,v) do { GLFuncPtrName(glVertexAttrib4uiv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib4uiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttrib4usv
 *  @brief Specifies the value of a generic vertex attribute
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] v Specifies a pointer to an array of values to be used for the generic vertex attribute.
 */
#define glVertexAttrib4usv(index,v) do { GLFuncPtrName(glVertexAttrib4usv)(index, v); GL_AUTOCHECK_BLOCK("glVertexAttrib4usv", __FILE__, __LINE__); } while(0)

/**
 *  @def glVertexAttribPointer
 *  @brief define an array of generic vertex attribute data
 *  @param[in] index Specifies the index of the generic vertex attribute to be modified.
 *  @param[in] size Specifies the number of components per generic vertex attribute. Must be 1, 2,
 *      3, 4. Additionally, the symbolic constant GL_BGRA is accepted by glVertexAttribPointer. The
 *      initial value is 4.
 *  @param[in] type Specifies the data type of each component in the array. The symbolic constants
 *      GL_BYTE, GL_UNSIGNED_BYTE, GL_SHORT, GL_UNSIGNED_SHORT, GL_INT, and GL_UNSIGNED_INT are
 *      accepted by both functions. Additionally GL_HALF_FLOAT, GL_FLOAT, GL_DOUBLE, GL_FIXED,
 *      GL_INT_2_10_10_10_REV, and GL_UNSIGNED_INT_2_10_10_10_REV are accepted by
 *      glVertexAttribPointer. The initial value is GL_FLOAT.
 *  @param[in] normalized For glVertexAttribPointer , specifies whether fixed-point data values
 *      should be normalized ( GL_TRUE ) or converted directly as fixed-point values ( GL_FALSE)
 *      when they are accessed.
 *  @param[in] stride Specifies the byte offset between consecutive generic vertex attributes. If
 *      stride is 0, the generic vertex attributes are understood to be tightly packed in the array.
 *      The initial value is 0.
 *  @param[in] pointer Specifies a offset of the first component of the first generic vertex
 *      attribute in the array in the data store of the buffer currently bound to the
 *      GL_ARRAY_BUFFER target. The initial value is 0.
 */
#define glVertexAttribPointer(index,size,type,normalized,stride,pointer) do { GLFuncPtrName(glVertexAttribPointer)(index, size, type, normalized, stride, pointer); GL_AUTOCHECK_BLOCK("glVertexAttribPointer", __FILE__, __LINE__); } while(0)

#endif // GL_VERSION_2_0

//                              --- ~OpenGL 2.0 ---

